/*
 * URL Shortener API
 * This API is responsible of authetication and the creation, modification and deletion of uris and hooks.
 *
 * OpenAPI spec version: 0.2.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.9
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/HookActionHTTP', 'model/HookActionMail', 'model/HookTrigger'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./HookActionHTTP'), require('./HookActionMail'), require('./HookTrigger'));
  } else {
    // Browser globals (root is window)
    if (!root.UrlShortenerApi) {
      root.UrlShortenerApi = {};
    }
    root.UrlShortenerApi.Hook = factory(root.UrlShortenerApi.ApiClient, root.UrlShortenerApi.HookActionHTTP, root.UrlShortenerApi.HookActionMail, root.UrlShortenerApi.HookTrigger);
  }
}(this, function(ApiClient, HookActionHTTP, HookActionMail, HookTrigger) {
  'use strict';

  /**
   * The Hook model module.
   * @module model/Hook
   * @version 0.2.0
   */

  /**
   * Constructs a new <code>Hook</code>.
   * @alias module:model/Hook
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>Hook</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Hook} obj Optional instance to populate.
   * @return {module:model/Hook} The populated <code>Hook</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('hookId'))
        obj.hookId = ApiClient.convertToType(data['hookId'], 'Number');
      if (data.hasOwnProperty('userId'))
        obj.userId = ApiClient.convertToType(data['userId'], 'Number');
      if (data.hasOwnProperty('uriId'))
        obj.uriId = ApiClient.convertToType(data['uriId'], 'String');
      if (data.hasOwnProperty('active'))
        obj.active = ApiClient.convertToType(data['active'], 'Boolean');
      if (data.hasOwnProperty('trigger'))
        obj.trigger = HookTrigger.constructFromObject(data['trigger']);
      if (data.hasOwnProperty('actionsHTTP'))
        obj.actionsHTTP = ApiClient.convertToType(data['actionsHTTP'], [HookActionHTTP]);
      if (data.hasOwnProperty('actionsMail'))
        obj.actionsMail = ApiClient.convertToType(data['actionsMail'], [HookActionMail]);
    }
    return obj;
  }

  /**
   * @member {Number} hookId
   */
  exports.prototype.hookId = undefined;

  /**
   * @member {Number} userId
   */
  exports.prototype.userId = undefined;

  /**
   * @member {String} uriId
   */
  exports.prototype.uriId = undefined;

  /**
   * @member {Boolean} active
   */
  exports.prototype.active = undefined;

  /**
   * @member {module:model/HookTrigger} trigger
   */
  exports.prototype.trigger = undefined;

  /**
   * @member {Array.<module:model/HookActionHTTP>} actionsHTTP
   */
  exports.prototype.actionsHTTP = undefined;

  /**
   * @member {Array.<module:model/HookActionMail>} actionsMail
   */
  exports.prototype.actionsMail = undefined;

  return exports;

}));
